Attribute VB_Name = "Module1"
Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Dim OFName As OPENFILENAME, TimerID
Public Function ShowOpen(hWndOwner As String) As String
    OFName.lStructSize = Len(OFName)
    OFName.hWndOwner = hWndOwner
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = "All Files (*.*)" + Chr$(0) + "*.*"
    OFName.lpstrFile = String(254, 0)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = String(254, 0)
    OFName.nMaxFileTitle = 255
    OFName.lpstrTitle = "Open File - KPD-Team 1999"
    
    SetTimer hWndOwner, TimerID, 10, AddressOf TimerProc
    LockWindowUpdate GetDesktopWindow
    If GetOpenFileName(OFName) Then
        ShowOpen = Left$(OFName.lpstrFile, InStr(1, OFName.lpstrFile, Chr$(0)) - 1)
    End If
End Function
Public Sub TimerProc()
    Dim mWnd As Long, R As RECT
    mWnd = FindWindow("#32770", OFName.lpstrTitle)
    If mWnd <> 0 Then
        KillTimer hwnd, TimerID
        GetWindowRect mWnd, R
        MoveWindow mWnd, ((Screen.Width / Screen.TwipsPerPixelX) - (R.Right - R.Left)) / 2, ((Screen.Height / Screen.TwipsPerPixelY) - (R.Bottom - R.Top)) / 2, R.Right - R.Left, R.Bottom - R.Top, False
        LockWindowUpdate False
    End If
End Sub
